
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.Actions.DATA &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for Voyager.Actions.DATA</h1><div class="highlight"><pre>
<span></span>
<span class="c1">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                              #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com              #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>
<span class="kn">from</span> <span class="nn">libtbx.phil</span> <span class="kn">import</span> <span class="n">parse</span>

<span class="n">install_aliases</span><span class="p">()</span>

<span class="kn">import</span> <span class="nn">sys</span><span class="o">,</span><span class="nn">os</span><span class="o">,</span><span class="nn">copy</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">from</span> <span class="nn">voyager_actions</span> <span class="kn">import</span> <span class="n">Action</span>

<span class="c1">#DISCLAIMER#</span>
<span class="c1">#This class has been generated automatically through strategy_app.py</span>
<span class="c1">#The app does not verify the correctness of the written code</span>
<span class="c1">#Please validate the class before use and manually inspect and correct any error</span>

<div class="viewcode-block" id="DATA_exception"><a class="viewcode-back" href="../../../Voyager.Actions.DATA.html#Voyager.Actions.DATA.DATA_exception">[docs]</a><span class="k">class</span> <span class="nc">DATA_exception</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">msg</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">DATA_exception</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="DATA"><a class="viewcode-back" href="../../../Voyager.Actions.DATA.html#Voyager.Actions.DATA.DATA">[docs]</a><span class="k">class</span> <span class="nc">DATA</span><span class="p">(</span><span class="n">Action</span><span class="p">):</span>
    <span class="n">info_dag_nodes</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;hkl_input&quot;</span><span class="p">:</span><span class="s2">&quot;0&quot;</span><span class="p">,</span><span class="s2">&quot;hkl_output&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">,</span><span class="s2">&quot;model_input&quot;</span><span class="p">:</span><span class="s2">&quot;0&quot;</span><span class="p">,</span><span class="s2">&quot;model_output&quot;</span><span class="p">:</span><span class="s2">&quot;0&quot;</span><span class="p">,</span><span class="s2">&quot;occurrences&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">}</span>
    <span class="n">rule</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;[[&quot;None&quot;]]&quot;&quot;&quot;</span>
    <span class="n">phasertngphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;</span>
<span class="s2">&quot;&quot;&quot;</span>
    <span class="n">masterphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;voyager.DATA {</span>

<span class="s2">}&quot;&quot;&quot;</span>
    <span class="n">helpstring</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot; This action is reading from the phil file the path to the mtz of cif file for the reflections and prepare everything to run data mode in phasertng.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;DATA&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="n">strategy</span><span class="o">.</span><span class="n">arguments</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">DATA</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">)</span>
        
        
<div class="viewcode-block" id="DATA.check_imports"><a class="viewcode-back" href="../../../Voyager.Actions.DATA.html#Voyager.Actions.DATA.DATA.check_imports">[docs]</a>    <span class="k">def</span> <span class="nf">check_imports</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">b</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;test() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">c</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">help</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;help() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">d</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_name</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;get_name() method has not been implemented!&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx&quot;</span><span class="p">)</span>


        <span class="k">return</span> <span class="kc">True</span></div>

<div class="viewcode-block" id="DATA.test"><a class="viewcode-back" href="../../../Voyager.Actions.DATA.html#Voyager.Actions.DATA.DATA.test">[docs]</a>    <span class="k">def</span> <span class="nf">test</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1">#TODO: perform a complete self contained test</span>
        <span class="k">pass</span></div>
    
<div class="viewcode-block" id="DATA.help"><a class="viewcode-back" href="../../../Voyager.Actions.DATA.html#Voyager.Actions.DATA.DATA.help">[docs]</a>    <span class="k">def</span> <span class="nf">help</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">helpstring</span></div>
    
<div class="viewcode-block" id="DATA.get_name"><a class="viewcode-back" href="../../../Voyager.Actions.DATA.html#Voyager.Actions.DATA.DATA.get_name">[docs]</a>    <span class="k">def</span> <span class="nf">get_name</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span></div>
    
<div class="viewcode-block" id="DATA.run"><a class="viewcode-back" href="../../../Voyager.Actions.DATA.html#Voyager.Actions.DATA.DATA.run">[docs]</a>    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_start</span><span class="p">()</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;logger&quot;</span><span class="p">):</span> <span class="k">raise</span> <span class="n">DATA_exception</span><span class="p">(</span><span class="s2">&quot;Logger File has not been set. Please call &#39;set_logger_file&#39; method before run&quot;</span><span class="p">)</span>
        <span class="n">user_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">python_object</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="n">diffuser_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">user_phil</span><span class="p">)</span>
        <span class="n">action_phil</span> <span class="o">=</span> <span class="n">parse</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">current_phil_keywords</span><span class="p">)</span>
        <span class="n">diffaction_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">action_phil</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">sources</span><span class="o">=</span><span class="p">[</span><span class="n">diffaction_phil</span><span class="p">,</span> <span class="n">diffuser_phil</span><span class="p">])</span><span class="o">.</span><span class="n">extract</span><span class="p">()</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">data</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_end</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">output</span></div>

<div class="viewcode-block" id="DATA.data"><a class="viewcode-back" href="../../../Voyager.Actions.DATA.html#Voyager.Actions.DATA.DATA.data">[docs]</a>    <span class="k">def</span> <span class="nf">data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">):</span>
        <span class="n">root</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">initial_dag_nodes</span>
        <span class="k">if</span> <span class="n">root</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">root</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">len</span><span class="p">(</span><span class="n">root</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">root</span> <span class="o">=</span> <span class="n">root</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="s2">&quot;This action only support one single input dag node&quot;</span><span class="p">)</span>
            <span class="k">raise</span> <span class="n">DATA_exception</span><span class="p">(</span><span class="s2">&quot;This action only support one single input dag node&quot;</span><span class="p">)</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="n">p</span> <span class="o">=</span> <span class="p">[</span><span class="n">s</span> <span class="k">for</span> <span class="n">path</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">all_simple_path_from_root_to</span><span class="p">(</span><span class="n">root</span><span class="p">)</span> <span class="k">for</span> <span class="n">s</span> <span class="ow">in</span> <span class="n">path</span> <span class="k">if</span>
             <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">s</span><span class="p">)[</span><span class="s2">&quot;name&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;data&quot;</span><span class="p">]</span>

            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">p</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Data already prensent in phaser dag, this action is redundant. Skipping...&quot;</span><span class="p">)</span>
                <span class="k">return</span> <span class="n">root</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">pass</span>

        <span class="n">mtz</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">reflections</span>
        <span class="n">mtz_label</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">i</span> <span class="k">if</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">i</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="n">mtz_label</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span> <span class="n">mtz_label</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">f</span> <span class="k">if</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">f</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="k">else</span> <span class="kc">None</span>

        <span class="n">symbol_and_number</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="n">mtz</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">mtz</span><span class="p">):</span>
            <span class="n">mtzobj</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span><span class="o">.</span><span class="n">file_reader</span><span class="o">.</span><span class="n">any_file</span><span class="p">(</span><span class="n">mtz</span><span class="p">)</span>
            <span class="n">symbol_and_number</span> <span class="o">=</span> <span class="n">mtzobj</span><span class="o">.</span><span class="n">crystal_symmetry</span><span class="p">()</span><span class="o">.</span><span class="n">space_group</span><span class="p">()</span><span class="o">.</span><span class="n">info</span><span class="p">()</span><span class="o">.</span><span class="n">symbol_and_number</span><span class="p">()</span>
            <span class="n">reflections</span> <span class="o">=</span> <span class="n">mtzobj</span><span class="o">.</span><span class="n">file_object</span><span class="o">.</span><span class="n">as_miller_arrays</span><span class="p">()</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="n">mtz</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s2">&quot;.mtz&quot;</span><span class="p">):</span>
                <span class="n">mtz_dataset</span> <span class="o">=</span> <span class="kc">None</span>
                <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">ref</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">reflections</span><span class="p">):</span>
                    <span class="k">if</span> <span class="n">ref</span><span class="o">.</span><span class="n">is_xray_intensity_array</span><span class="p">()</span> <span class="ow">or</span> <span class="n">ref</span><span class="o">.</span><span class="n">is_xray_amplitude_array</span><span class="p">():</span>
                        <span class="k">try</span><span class="p">:</span>
                            <span class="n">labels</span> <span class="o">=</span> <span class="s2">&quot;I&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span> <span class="o">+</span> <span class="n">ref</span><span class="o">.</span><span class="n">info</span><span class="p">()</span><span class="o">.</span><span class="n">label_string</span><span class="p">()</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">)[</span><span class="mi">0</span><span class="p">][:</span><span class="mi">5</span><span class="p">]</span> <span class="k">if</span> <span class="n">ref</span><span class="o">.</span><span class="n">is_xray_intensity_array</span><span class="p">()</span> <span class="k">else</span> <span class="s2">&quot;F&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span> <span class="o">+</span> \
                                                                                              <span class="n">ref</span><span class="o">.</span><span class="n">info</span><span class="p">()</span><span class="o">.</span><span class="n">label_string</span><span class="p">()</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">)[</span><span class="mi">0</span><span class="p">][:</span><span class="mi">5</span><span class="p">]</span>
                            <span class="k">if</span> <span class="ow">not</span> <span class="n">mtz_dataset</span><span class="p">:</span>
                                <span class="n">mtz_dataset</span> <span class="o">=</span> <span class="n">ref</span><span class="o">.</span><span class="n">as_mtz_dataset</span><span class="p">(</span><span class="n">column_root_label</span><span class="o">=</span><span class="n">labels</span><span class="p">)</span>
                            <span class="k">else</span><span class="p">:</span>
                                <span class="n">mtz_dataset</span><span class="o">.</span><span class="n">add_miller_array</span><span class="p">(</span><span class="n">ref</span><span class="p">,</span> <span class="n">column_root_label</span><span class="o">=</span><span class="n">labels</span><span class="p">)</span>
                        <span class="k">except</span><span class="p">:</span>
                            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Cannot add: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">ref</span><span class="o">.</span><span class="n">info</span><span class="p">()</span><span class="o">.</span><span class="n">label_string</span><span class="p">()))</span>

                <span class="k">if</span> <span class="ow">not</span> <span class="n">mtz_dataset</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="s2">&quot;FATAL ERROR. Cannot convert .cif file into mtz for phasertng. EXIT.&quot;</span><span class="p">)</span>
                    <span class="k">raise</span> <span class="n">DATA_exception</span><span class="p">(</span><span class="s2">&quot;FATAL ERROR. Cannot convert .cif file into mtz for phasertng. EXIT.&quot;</span><span class="p">)</span>

                <span class="n">mtz</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">phasertng_dir</span><span class="p">,</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">mtz</span><span class="p">)[:</span><span class="o">-</span><span class="mi">4</span><span class="p">]</span> <span class="o">+</span> <span class="s2">&quot;.mtz&quot;</span><span class="p">)</span>
                <span class="n">mtz_dataset</span><span class="o">.</span><span class="n">mtz_object</span><span class="p">()</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">mtz</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">reflections</span> <span class="o">=</span> <span class="kc">None</span>

        <span class="k">if</span> <span class="n">reflections</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span>
                <span class="s2">&quot;FATAL ERROR. The path to the mtz inserted does not correspond to a valid reflection file. Please correct and restart the program.&quot;</span><span class="p">)</span>
            <span class="k">raise</span> <span class="n">DATA_exception</span><span class="p">(</span>
                <span class="s2">&quot;FATAL ERROR. The path to the mtz inserted does not correspond to a valid reflection file. Please correct and restart the program.&quot;</span><span class="p">)</span>

        <span class="n">miller_array</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">is_xray_intensity</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="n">mtz_label</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">ref</span> <span class="ow">in</span> <span class="n">reflections</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">mtz_label</span> <span class="ow">in</span> <span class="n">ref</span><span class="o">.</span><span class="n">info</span><span class="p">()</span><span class="o">.</span><span class="n">label_string</span><span class="p">()</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">):</span>
                    <span class="n">miller_array</span> <span class="o">=</span> <span class="n">ref</span>
                    <span class="n">is_xray_intensity</span> <span class="o">=</span> <span class="n">ref</span><span class="o">.</span><span class="n">is_xray_intensity_array</span><span class="p">()</span>
                    <span class="n">mtz_label</span> <span class="o">=</span> <span class="n">ref</span><span class="o">.</span><span class="n">info</span><span class="p">()</span><span class="o">.</span><span class="n">label_string</span><span class="p">()</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">)</span>
                    <span class="k">break</span>

            <span class="k">if</span> <span class="n">miller_array</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span>
                    <span class="s2">&quot;FATAL ERROR. The Labels for the mtz that have been provided are not found in the mtz file. Please correct and restart the program&quot;</span><span class="p">)</span>
                <span class="k">raise</span> <span class="n">DATA_exception</span><span class="p">(</span>
                    <span class="s2">&quot;FATAL ERROR. The Labels for the mtz that have been provided are not found in the mtz file. Please correct and restart the program&quot;</span><span class="p">)</span>

            <span class="n">dmax</span><span class="p">,</span> <span class="n">dmin</span> <span class="o">=</span> <span class="n">miller_array</span><span class="o">.</span><span class="n">d_max_min</span><span class="p">()</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;&quot;</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;--------------------------------MTZ PROVIDED-----------------------------------&quot;</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Mtz at: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">mtz</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Selected Miller indeces: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">miller_array</span><span class="o">.</span><span class="n">info</span><span class="p">()</span><span class="o">.</span><span class="n">label_string</span><span class="p">()))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Number of unique reflections: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">miller_array</span><span class="o">.</span><span class="n">size</span><span class="p">()))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Highest Resolution: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">dmin</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Lowest Resolution: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">dmax</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;-------------------------------------------------------------------------------&quot;</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;&quot;</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;&quot;</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;--------------------------------MTZ PROVIDED-----------------------------------&quot;</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Mtz at: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">mtz</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;-------------------------------------------------------------------------------&quot;</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;&quot;</span><span class="p">)</span>
            <span class="n">is_xray_intensity</span> <span class="o">=</span> <span class="kc">None</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">current_phil_keywords_phasertng</span> <span class="o">+=</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">phasertng.hklin.filepath = &quot;</span><span class="o">+</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">mtz</span><span class="p">))[</span><span class="mi">0</span><span class="p">]</span><span class="o">+</span><span class="s2">&quot; </span><span class="se">\n</span><span class="s2">&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">current_phil_keywords_phasertng</span> <span class="o">+=</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">phasertng.hklin.filename = &quot;</span><span class="o">+</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">mtz</span><span class="p">))</span><span class="o">+</span><span class="s2">&quot; </span><span class="se">\n</span><span class="s2">&quot;</span>

        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">mode_data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">debug</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">tngverbose</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">verbose</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="n">output</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">notify_error</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">)</span>
            <span class="k">raise</span> <span class="n">DATA_exception</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">)</span>

        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">notify_warning</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">)</span>

        <span class="n">symbol</span> <span class="o">=</span> <span class="n">symbol_and_number</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;(&quot;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="n">number</span> <span class="o">=</span> <span class="n">symbol_and_number</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;No.&quot;</span><span class="p">)[</span><span class="mi">1</span><span class="p">][:</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="n">data</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;resolution&quot;</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">working_parameters</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">resolution_available</span><span class="p">,</span><span class="s2">&quot;spacegroup&quot;</span><span class="p">:</span><span class="n">symbol</span><span class="p">,</span> <span class="s2">&quot;number&quot;</span><span class="p">:</span><span class="n">number</span><span class="p">}</span>
        <span class="n">nd</span><span class="p">,</span> <span class="n">node_nd</span> <span class="o">=</span> \
        <span class="bp">self</span><span class="o">.</span><span class="n">schedule_add_node_hkl</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">dag_phil_str_list</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">dag_cards_str_list</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">working_dag_list</span><span class="p">,</span>
                                   <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">working_parameters</span><span class="p">,</span> <span class="s2">&quot;data&quot;</span><span class="p">,</span> <span class="n">root</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">associated_strategy_node</span><span class="p">,</span> <span class="n">data</span><span class="o">=</span><span class="n">data</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>

        <span class="k">return</span> <span class="n">nd</span></div></div>

</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>